#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <ns>

stock Float:pev_f(_index,_field)
{
	new Float:f
	pev(_index,_field,f)
	return f
}

public plugin_init() 
{ 
	register_plugin("NS Status Bar","1.04","Cheesy Peteza")
	register_cvar("amx_nsstatusbar_version", "1.04", FCVAR_EXTDLL | FCVAR_SERVER)
	set_task(0.5,"checklookingat",0,"",0,"ab")
} 

public checklookingat() 
{
	new entity, part

	for(new i = 1; i <= get_maxplayers(); ++i) 
	{
		get_user_aiming(i, entity, part)
		
		if (is_valid_ent(entity)) 
		{
			new health = get_user_health(entity)
			new statustext[128]
			new myteam[32]

			get_user_team(i,myteam,31)

			if (health)
			{
				new name[32]
				new lateam[32]

				get_user_team(entity,lateam,31)
				
				if (equal(myteam, lateam) || equal(myteam, "spectatorteam")) 
				{
					get_user_name(entity,name,31)
					
					if (equal(lateam, "marine1team")) 
					{
						format(statustext, 127, "%s^nHealth %d/%d Armor %d", name, health, floatround(pev_f(entity, pev_max_health)), get_user_armor(entity))
						if (ns_get_mask(entity,MASK_PARASITED)) add(statustext, 127, "^n(Parasited)")
					} 
					else if (equal(lateam, "alien1team")) 
					{
						if(ns_get_res(entity) && ns_is_combat())
							format(statustext, 127, "%s^nHealth %d/%d Armor %d Res %d^n", name, health, floatround(pev_f(entity, pev_max_health)), get_user_armor(entity), floatround(ns_get_res(entity)))						
						else
							format(statustext, 127, "%s^nHealth %d/%d Armor %d^n", name, health, floatround(pev_f(entity, pev_max_health)), get_user_armor(entity))						
												
						if (ns_get_mask(entity,MASK_CARAPACE)) add(statustext, 127, "Carapace ")
						else if (ns_get_mask(entity,MASK_REGENERATION)) add(statustext, 127, "Regeneration ")
						else if (ns_get_mask(entity,MASK_REDEMPTION)) add(statustext, 127, "Redemption ")
						if (ns_get_mask(entity,MASK_CELERITY)) add(statustext, 127, "Celerity ")
						else if (ns_get_mask(entity,MASK_ADRENALINE)) add(statustext, 127, "Adrenaline ")
						else if (ns_get_mask(entity,MASK_SILENCE)) add(statustext, 127, "Silence ")
						if (ns_get_mask(entity,MASK_CLOAKING)) add(statustext, 127, "Cloaking")
						else if (ns_get_mask(entity,MASK_FOCUS)) add(statustext, 127, "Focus")
						else if (ns_get_mask(entity,MASK_SCENTOFFEAR)) add(statustext, 127, "Scent of Fear")  
					}
				}
			} else if ( (pev(i, pev_team) == pev(entity, pev_team)) || equal(myteam, "spectatorteam")) 
			{
				// Structure & Player belong to same team, or they are spectator
				
				new Float:shealth = pev_f(entity, pev_health)
				
				if (shealth != 0) 
				{
					new sname[32]

					switch (pev(entity, pev_iuser3)) 
					{
						case 17:	sname = "Hive"
						case 23:	sname = "Command Console"
						case 24:	sname = "Turret Factory"
						case 25:	sname = "Armory"
						case 26:	sname = "Advanced Armory"
						case 27:	sname = "Arms Lab"
						case 28:	sname = "Prototype Lab"
						case 29:	sname = "Observatory"
						case 33:	sname = "Turret"
						case 34:	sname = "Siege Turret"
						case 35:	sname = "Resource Tower"
						case 37:	sname = "Infantry Portal"
						case 41:	sname = "Phasegate"
						case 42:	sname = "Defense Chamber"
						case 43:	sname = "Movement Chamber"
						case 44:	sname = "Offense Chamber"
						case 45:	sname = "Sensory Chamber"
						case 46:	sname = "Resource Chamber"
						case 49:	sname = "Advanced Turret Factory"
					}
					
					format(statustext, 127, "%s^nHealth: %d", sname, floatround(shealth))
					
					if (ns_get_mask(entity,MASK_RECYCLING )) 
						add(statustext, 127, "^nRecycling...")
					else if (ns_get_mask(entity,MASK_PARASITED)) 
						add(statustext, 127, "^n(Parasited)")
				}
			}
			
			client_print(i,print_center,statustext)
			
		}
	}
}
